<script lang="ts">
	import { onMount } from 'svelte';
	import { marked } from 'marked';
	import { markedHighlight } from 'marked-highlight';
	import { Card } from 'flowbite-svelte';
	import type { BlogPost } from '$lib/data/blog-data';
	import Prism from 'prismjs';
	// Import specific languages
	import 'prismjs/components/prism-sql';
	import 'prismjs/components/prism-bash';
	import 'prismjs/components/prism-python';
	import 'prismjs/components/prism-css';
	import 'prismjs/components/prism-cshtml';
    import 'prismjs/components/prism-hcl';

	// Import a theme
	import 'prismjs/themes/prism-tomorrow.css';

	//export let data: { post: BlogPost };
	let { data } = $props();
	let content = $state('');

	// Configure marked with the markedHighlight extension

	marked.use(
		markedHighlight({
			langPrefix: 'language-',
			highlight(code, lang) {
				if (lang && Prism.languages[lang]) {
					try {
						return Prism.highlight(code, Prism.languages[lang], lang);
					} catch (e) {
						console.error(e);
					}
				}
				return code;
			}
		})
	);

	function formatDate(dateString: string) {
		const date = new Date(dateString);
		return date.toLocaleDateString('en-US', {
			year: 'numeric',
			month: 'long',
			day: 'numeric'
		});
	}

	$effect(() => {
		(async () => {
			try {
				const response = await fetch(`/blog-content/${data.post.id}.md`);
				const markdown = await response.text();
				content = marked.parse(markdown).toString();
			} catch (error) {
				console.error('Error loading blog content:', error);
				content = '<p>Error loading blog content</p>';
			}
		})();
	});
</script>

<div id="BlogContainer" class="w-full py-8">
	<Card id="PostCard" class="!w-full !max-w-none mx-auto max-w-6xl bg-gray-50">
		{#if data.post.coverImage}
			<img
				src={data.post.coverImage}
				alt={data.post.title}
				class="mb-8 h-[400px] w-full object-cover"
			/>
		{/if}

		<div class="w-full px-8 lg:px-16">
			<header class="mb-12 text-center">
				<h1 class="mb-4 text-4xl font-bold md:text-5xl">
					{data.post.title}
				</h1>

				<div class="mb-6 flex items-center justify-center gap-4 text-gray-600">
					<span>{formatDate(data.post.date)}</span>
					<span>•</span>
					<span>By {data.post.author}</span>
				</div>

				<div class="flex flex-wrap justify-center gap-2">
					{#each data.post.tags as tag}
						<span
							class="inline-flex items-center rounded-full bg-blue-100 px-3 py-1 text-sm font-medium text-blue-800"
						>
							{tag}
						</span>
					{/each}
				</div>
			</header>

			<div class="prose prose-lg max-w-none">
				{@html content}
			</div>
		</div>
	</Card>

	<div class="mx-auto mt-8 flex max-w-4xl items-center justify-between px-8">
		<a href="/blog" class="flex items-center gap-2 text-blue-600 hover:text-blue-800">
			← Back to all posts
		</a>

		<div class="flex gap-4">
			<button class="text-gray-600 hover:text-blue-600" title="Share on Twitter"> Share </button>
		</div>
	</div>
</div>

<style>
	/* Override Flowbite Card max-width */
	:global(.card) {
		max-width: none !important;
		width: 100% !important;
	}

	/* Base prose styles */
	:global(.prose) {
		font-family:
			ui-sans-serif,
			system-ui,
			-apple-system,
			BlinkMacSystemFont,
			'Segoe UI',
			Roboto,
			'Helvetica Neue',
			Arial,
			sans-serif;
	}

	/* Heading styles */
	:global(.prose h1) {
		font-size: 2.25em;
		margin-top: 0;
		margin-bottom: 0.8888889em;
		line-height: 1.1111111;
		font-weight: 700;
	}

	:global(.prose h2) {
		font-size: 1.5em;
		margin-top: 2em;
		margin-bottom: 1em;
		line-height: 1.3333333;
		font-weight: 600;
		color: #111827;
	}

	:global(.prose h3) {
		font-size: 1.25em;
		margin-top: 1.6em;
		margin-bottom: 0.6em;
		line-height: 1.6;
		font-weight: 600;
		color: #111827;
	}

	:global(.prose h4) {
		margin-top: 1.5em;
		margin-bottom: 0.5em;
		line-height: 1.5;
		font-weight: 600;
		color: #111827;
	}

	/* Paragraph styles */
	:global(.prose p) {
		margin-top: 1.25em;
		margin-bottom: 1.25em;
		line-height: 1.8;
	}

	/* List styles */
	:global(.prose ul) {
		margin-top: 1.25em;
		margin-bottom: 1.25em;
		padding-left: 1.625em;
		list-style-type: disc;
	}

	:global(.prose ol) {
		margin-top: 1.25em;
		margin-bottom: 1.25em;
		padding-left: 1.625em;
		list-style-type: decimal;
	}

	:global(.prose li) {
		margin-top: 0.5em;
		margin-bottom: 0.5em;
	}

	/* Code block styles */
	:global(.prose pre) {
		margin: 1.5em 0;
		padding: 1.5em;
		border-radius: 0.5em;
		overflow-x: auto;
		background-color: #2d2d2d !important;
		color: #e5e7eb;
	}

	:global(.prose pre code) {
		background-color: transparent;
		padding: 0;
		border-radius: 0;
		font-size: 0.9em;
		font-family: ui-monospace, SFMono-Regular, Menlo, Monaco, Consolas, 'Liberation Mono',
			'Courier New', monospace;
		color: #e5e7eb;
	}

	/* Inline code style */
	:global(.prose :not(pre) > code) {
		background-color: #f3f4f6;
		color: #111827;
		padding: 0.2em 0.4em;
		border-radius: 0.25em;
		font-size: 0.9em;
	}

	/* Blockquote styles */
	:global(.prose blockquote) {
		margin-top: 1.6em;
		margin-bottom: 1.6em;
		border-left-width: 4px;
		border-left-color: #3b82f6;
		background-color: #f3f4f6;
		padding: 1em 1.5em;
		border-radius: 0.5em;
		font-style: italic;
		color: #4b5563;
	}

	/* Image styles */
	:global(.prose img) {
		border-radius: 0.5em;
		margin: 2em 0;
		max-width: 100%;
		height: auto;
		align-self: center;
	}

	/* Table styles */
	:global(.prose table) {
		width: 100%;
		margin-top: 2em;
		margin-bottom: 2em;
		border-collapse: collapse;
		font-size: 0.9em;
	}

	:global(.prose th) {
		background-color: #f3f4f6;
		padding: 0.75em;
		text-align: left;
		font-weight: 600;
	}

	:global(.prose td) {
		padding: 0.75em;
		border-bottom: 1px solid #e5e7eb;
	}

	/* Grid layout styles */
	:global(.prose .grid-cols-3) {
		display: grid;
		grid-template-columns: repeat(1, minmax(0, 1fr));
		gap: 2rem;
		margin: 2rem 0;
	}

	@media (min-width: 768px) {
		:global(.prose .grid-cols-3) {
			grid-template-columns: repeat(3, minmax(0, 1fr));
		}
	}

	:global(.prose .grid-cols-3 .col) {
		break-inside: avoid;
	}

	:global(.prose .grid-cols-3 .col > *:first-child) {
		margin-top: 0 !important;
	}

	:global(.prose .grid-cols-3 .col > *:last-child) {
		margin-bottom: 0 !important;
	}

	/* Preserve markdown styling within columns */
	:global(.prose .grid-cols-3 h3) {
		font-size: 1.25em;
		margin-top: 1.6em;
		margin-bottom: 0.6em;
		line-height: 1.6;
		font-weight: 600;
		color: #111827;
	}

	:global(.prose .grid-cols-3 ul),
	:global(.prose .grid-cols-3 ol) {
		margin: 1rem 0;
		padding-left: 1.25rem;
	}

	:global(.prose .grid-cols-3 li) {
		margin: 0.5rem 0;
	}

	:global(.prose .grid-cols-3 pre) {
		margin: 1rem 0;
		font-size: 0.85em;
	}

	:global(.prose a) {
        color: #2563eb; /* blue-600 */
        text-decoration: none;
        font-weight: 500;
        transition: all 0.2s ease-in-out;
        border-bottom: 1px solid transparent;
    }

    :global(.prose a:hover) {
        color: #1d4ed8; /* blue-700 */
        border-bottom: 1px solid currentColor;
    }

    :global(.prose a:focus) {
        outline: 2px solid #3b82f6; /* blue-500 */
        outline-offset: 2px;
        border-radius: 0.25rem;
    }

    /* External link styles (optional) */
    :global(.prose a[href^="http"]:not([href*="your-domain.com"])) {
        padding-right: 1.25em;
        background: url('data:image/svg+xml;utf8,<svg xmlns="http://www.w3.org/2000/svg" fill="%232563eb" viewBox="0 0 24 24" width="12" height="12"><path d="M10 6v2H5v11h11v-5h2v6a1 1 0 0 1-1 1H4a1 1 0 0 1-1-1V7a1 1 0 0 1 1-1h6zm11-3v8h-2V6.413l-7.793 7.794-1.414-1.414L17.585 5H13V3h8z"/></svg>') no-repeat right center;
        background-size: 1em;
    }

    /* Link styles in headings */
    :global(.prose h1 a),
    :global(.prose h2 a),
    :global(.prose h3 a),
    :global(.prose h4 a) {
        color: inherit;
        font-weight: inherit;
        text-decoration: none;
        border-bottom: none;
    }

    :global(.prose h1 a:hover),
    :global(.prose h2 a:hover),
    :global(.prose h3 a:hover),
    :global(.prose h4 a:hover) {
        color: #2563eb;
        border-bottom: none;
    }

    /* Link styles in blockquotes */
    :global(.prose blockquote a) {
        color: #4b5563; /* gray-600 */
    }

    :global(.prose blockquote a:hover) {
        color: #2563eb;
    }

    /* Link styles in code blocks */
    :global(.prose pre a) {
        color: #e5e7eb; /* gray-200 */
        border-bottom: 1px dashed #6b7280;
    }

    :global(.prose pre a:hover) {
        color: #ffffff;
        border-bottom: 1px solid #ffffff;
    }

    /* Link styles in lists */
    :global(.prose li > a) {
        text-decoration: none;
    }
</style>